﻿//~ Script for splitting masks on one layer into separate masked layers
//~ USE: Select a layer with masks and run the script.

//~ Martin Brennand
//~ Imagineer Systems 2011
//~ With immense amount of help and thanks from aenhancers.com
//~ If you want to learn AE scripting, it's a great place to start.

//~ *PLEASE NOTE*
//~ This script is provided as a helping tool only.  It works for the task it was meant for, but has not been tested thoroughly.
//~ Please be aware that you use this script at your own risk.  We always recommend backing up your work before trying anything new.

var activeComp = app.project.activeItem; 
var layer = activeComp.selectedLayers[0] //Get the first item in the currently selected layers
var newLayer = new Array();
var newSlider = new Array();
var layermasks = layer("Masks"); //Get all the masks for the selected layer

if (layermasks != null) //If the layer actually has masks
{           
    var numProps = layermasks.numProperties; //Grab the number of masks in the layer
    var greylevel = 0;
    
    //Create a new layer for each mask in the selected layer
    for (var i = numProps;  i >= 1; i--) 
       {
            newLayer[i]= layer.duplicate();
            for (var j = newLayer[i]("Masks").numProperties; j >= 1; j--)
            {
                if(j != i)
                    newLayer[i]("Masks").property(j).remove();
            }      
            newLayer[i].name = newLayer[i]("Masks").property(1).name;  
            newLayer[i].Effects.addProperty("Fill"); //add a fill effect
            greyLevel = (i/numProps);
            newLayer[i].Effects.property("Fill")("Color").setValue([greyLevel,greyLevel,greyLevel,1]); //Set the color fill  to a grey level based on its layer position
       }
   
    // Adjustment layer for controlling each layer's mask feather
    var controlLayer= activeComp.layers.addSolid([1,1,1], "Shape Layer Control Panel", activeComp.width,activeComp.height,activeComp.pixelAspect,activeComp.duration);
    controlLayer.adjustmentLayer = true;
    
    for (var i = numProps;  i >= 1; i--) 
    {
        newSlider[i] = controlLayer.Effects.addProperty("Slider Control");
        newSlider[i].name = "Feather " + newLayer[i].name ;
        newLayer[i].mask(newLayer[i].name).maskFeather.expression ='[thisComp.layer("Shape Layer Control Panel").effect("'+newSlider[i].name+'")("Slider") ,thisComp.layer("Shape Layer Control Panel").effect("'+newSlider[i].name+'")("Slider") ]';
    }
}